/*
*  This script defines functions used by Confirm window
*
* Author: Stphane BERTIN
* http://bookmarkdd.mozdev.org
*
*/

// set window title
function confirmOnLoad(){
    document.title = document.getElementById("confirm-strings").getString("Confirm");
    confirmLoadText();
    
    var dialogButtons = document.getElementById("BookmarkDD-Confirm").getAttribute('buttons');
    var duplicateResources = window.arguments[1];
    if (!duplicateResources || (duplicateResources && duplicateResources.length != 1)) document.documentElement.getButton("extra1").setAttribute('hidden',true);

}

// set window text
function confirmLoadText(){

    // display text
    var messageText = window.arguments[0];
    var messageParent = document.getElementById("box-text");
    var messageParagraphs = messageText.split("\n");

    for (var i = 0; i < messageParagraphs.length; i++) {
	var descriptionNode = document.createElement("description");
	var text = document.createTextNode(messageParagraphs[i]);
	descriptionNode.appendChild(text);
	messageParent.appendChild(descriptionNode);
    }
}

function moveBookmark(){
    var duplicateResources = window.arguments[1];
    var selection = Bookmarkdd.createSelection(duplicateResources[0]);
    //BookmarksCommand.moveBookmark(selection); //DO not return BOOLEAN RESULT !!
    //It is a copy of BookmarksCommand.moveBookmark() function to use return value :-((
    var rv = { selectedFolder: null };      
    openDialog("chrome://browser/content/bookmarks/addBookmark.xul", "", 
               "centerscreen,chrome,modal=yes,dialog=yes,resizable=yes", null, 
               null, null, null, "selectFolder", rv);
    if (!rv.target) return; //If no folder is selected abort
    var result = BookmarksUtils.moveAndCheckSelection("move", selection, rv.target);

    if(result) window.close();
    return;
}
