//Test de remplacement
//PlacesUIUtils.showAddBookmarkUI = f_test ;
/*function f_test (aURI,
aTitle,
aDescription,
aDefaultInsertionPoint,
aShowPicker,
aLoadInSidebar,
aKeyword,
aPostData,
aCharSet) {
alert ("Parametres : "+aURI+ aTitle+ aDescription+ aDefaultInsertionPoint+ aShowPicker+ aLoadInSidebar+ aKeyword+ aPostData+ aCharSet);
}*/
//PlacesUIUtils.showAddBookmarkUI ("TEST_URI"+"toto"+"tutu"+null+null+null+null);
//
//


var bmsvc = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"]
    .getService(Components.interfaces.nsINavBookmarksService);
var livemarkService = Components.classes["@mozilla.org/browser/livemark-service;2"]
    .getService(Components.interfaces.nsILivemarkService);


// nsINavBookmarkObserver : Listener for Bookmarkdd extension
var Bdd_bookmarkListener = {
    onBeginUpdateBatch: function() {},
    onEndUpdateBatch: function() {},
    onItemAdded: function(aItemId, aFolder, aIndex) {
	Bookmarkdd.doItemAdded(aItemId,aFolder,aIndex);
    },
    onItemRemoved: function(aItemId, aFolder, aIndex) {},
    onItemChanged: function(aBookmarkId, aProperty, aIsAnnotationProperty, aValue) {
	//Bookmarkdd.doSomething(aBookmarkId,aValue,"Changed");
    },
    onItemVisited: function(aBookmarkId, aVisitID, time) {},
    onItemMoved: function(aItemId, aOldParent, aOldIndex, aNewParent, aNewIndex) {
	Bookmarkdd.doItemAdded(aItemId,aNewParent,aNewIndex);
    },
    QueryInterface: function(iid) {
	if (iid.equals(Ci.nsINavBookmarkObserver) || iid.equals(Ci.nsISupports)) {
	    return this;
	}
	throw Cr.NS_ERROR_NO_INTERFACE;
    }
};

// Extension property
var Bookmarkdd = {

    userResponse: false,

    onLoad: function() {
	bmsvc.addObserver(Bdd_bookmarkListener, false);
    },
    onUnLoad: function() {
	bmsvc.removeObserver(Bdd_bookmarkListener);
    },
    doItemAdded: function(aItemId,aFolderId,aIndex) {
	var thisURI = bmsvc.getBookmarkURI(aItemId);
	var itemType = bmsvc.getItemType(aItemId);
	//TYPE_BOOKMARK 	 1 	This is an index for type "Bookmark".
	//TYPE_FOLDER 	2 	This is an index for type "Folder".
	//TYPE_SEPARATOR 	3 	This is an index for type "Separator".
	//TYPE_DYNAMIC_CONTAINER  4 	This is an index for type "Dynamic Container".

	if (itemType == 1) {
	    //var parentFolderId = bmsvc.getFolderIdForItem(aItemId) = aFolderId;
	    var livemarkCheck = livemarkService.isLivemark(aFolderId); //if livemark return true
	    if (!livemarkCheck) {
		var bookmarksIdsForURI = bmsvc.getBookmarkIdsForURI(thisURI, {});
		if (bookmarksIdsForURI.length > 1) { // >1 then URL is duplicated
		    // Function used with forEach to delete aItemId in the array
		    function deleteElt(element, index, array) {
			if (element == aItemId) { array.splice(index,1); }
		    }
		    bookmarksIdsForURI.forEach(deleteElt);

		    var parentFoldersId = bookmarksIdsForURI.map(bmsvc.getFolderIdForItem);
		    //var parentTitle = parentFoldersId.map(bmsvc.getItemTitle); 
		    var parentTitle = parentFoldersId.map(this.findPath); 

		    var DuplicatesBundle = document.getElementById('duplicates-strings');
		    if (!DuplicatesBundle) {
			// Used by BookmarksPanelOverlay
			DuplicatesBundle = top.document.getElementById('duplicates-strings');
		    }
		    if (DuplicatesBundle){
			var message = DuplicatesBundle.getString("alreadyIn-Folder")+"\n";
			message += parentTitle.join("\n")+"\n";
			message += DuplicatesBundle.getString("alreadyIn-Confirm");
		    } else {
			alert("ECHEC");
			/*var message = Bookmarkdd.searchStringLocalisation("alreadyIn-Folder")+"\n";
			message += parentTitle.join("\n")+"\n";
			message += Bookmarkdd.searchStringLocalisation("alreadyIn-Confirm");*/
		    }
		    if(! BddConfirm(message)) bmsvc.removeItem(aItemId);

		    /* OK it works
		     * var result = confirm(" Uri="+thisURI.spec+"\n "+parentTitle.join("\n"));
		    if (!result) {
			//alert("Result = "+result);
			bmsvc.removeItem(aItemId);
		    }*/

		    //var stringF = PlacesUtils.getQueryStringForFolder(aFolderId);
		    //alert(" Uri="+thisURI.spec+"\n "+stringF);
		}
	    }
	} else {
	    alert("Type="+itemType+" Uri="+thisURI.spec);
	}

    },
    /*
     * input arguments : 
     * afolderId = an Folder Id
     * ouput : Return a chain of URL Parent Folder Name
     */
    findPath : function(afolderId) {
	var folderPath = new Array();
	var boucle = true;
	var itemType = bmsvc.getItemType(afolderId);
	if (itemType != 2) {
	    boucle = false;
	    //alert("Not a Folder"+bmsvc.getItemTitle(afolderId));
	}
	folderPath.push(bmsvc.getItemTitle(afolderId)); 
	if (afolderId == bmsvc.bookmarksMenuFolder || afolderId == bmsvc.tagsFolder || afolderId == bmsvc.unfiledBookmarksFolder || afolderId == bmsvc.toolbarFolder) {
	    boucle = false;
	}
	//alert("Is a Folder"+bmsvc.getItemTitle(afolderId));
	while (boucle){
	    //ParentResource = BMSVC.getParent(ParentResource);
	    afolderId = bmsvc.getFolderIdForItem(afolderId);
	    //bookmarksMenuFolder, tagsFolder, unfiledBookmarksFolder and toolbarFolder
	    if (afolderId == bmsvc.bookmarksMenuFolder || afolderId == bmsvc.tagsFolder || afolderId == bmsvc.unfiledBookmarksFolder || afolderId == bmsvc.toolbarFolder) {
		boucle = false;
	    }
	    folderPath.push(bmsvc.getItemTitle(afolderId)); 
	}
	folderPath.reverse();

	//alert("folderPath : "+folderPath.join(" > "));
	return folderPath.join(" > ");
    }
};

//BookmarkDD uses its own confirm window to replace default icon without overlay icon for all Browser's confirm
function BddConfirm(aText){

    //alert("aText = "+aText);
    window.openDialog("chrome://duplicates/content/Fx3/ConfirmOverlay.xul", "BookmarkDD-Confirm", "chrome,modal,alwaysRaised,resizable,centerscreen", aText);

    return Bookmarkdd.userResponse;
}
